import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.*;

public class Digit extends JLabel {
  private static final long serialVersionUID = -4719882476458914430L;
  private Board board;
  private BufferedImage image;

  private int value = 0;

  private final int HEIGHT = 23;
  private final int WIDTH = 13;

  public Digit(Board board) {
    super("", JLabel.CENTER);
    this.board = board;
    this.image = this.board.getMain().getImage().getDigit();
    this.setDigitIcon("0");
    setVerticalAlignment(JLabel.CENTER);
    setHorizontalAlignment(JLabel.CENTER);
    setPreferredSize(new Dimension(this.WIDTH, this.HEIGHT));
  }

  public int topMargin(String number) {
    String[] numbers = {
      "-", " ", "9", "8", "7", "6",
      "5", "4", "3", "2", "1", "0"
    };
    for (int i = 0; i < numbers.length; i += 1) {
      if (numbers[i].equals(number)) {
        return i;
      }
    }
    return 1;
  }

  public void setDigitIcon(String value) {
    setIcon(
        new ImageIcon(
            this.image.getSubimage(
                0, this.HEIGHT * this.topMargin(value), this.WIDTH, this.HEIGHT)));
  }

  public void setValue(int value) {
    this.value = value;
    this.setDigitIcon(String.valueOf(this.value));
  }
}
