import java.awt.*;
import javax.swing.*;
import javax.swing.BorderFactory;
import javax.swing.plaf.basic.BasicBorders.ButtonBorder;

public class Info extends JPanel {
  private static final long serialVersionUID = 3806487248823604535L;

  private Board board;
  private CounterDisplay counter;
  private Smiley smiley;
  private TimerDisplay timer;

  public Info(Minesweeper main) {
    this.board = main.getBoard();
    this.counter = new CounterDisplay(this.board);
    this.smiley = new Smiley(this.board);
    this.timer = new TimerDisplay(this.board);
    setBackground(new Color(192, 192, 192));
    setBorder(
        BorderFactory.createCompoundBorder(
            BorderFactory.createEmptyBorder(5, 5, 0, 5),
            new ButtonBorder(
                Color.white, Color.white, new Color(128, 128, 128), new Color(128, 128, 128))));
    setLayout(new BorderLayout());
    add(this.counter, "West");
    add(this.smiley, "Center");
    add(this.timer, "East");
    setVisible(true);
  }

  public CounterDisplay getCounter() {
    return this.counter;
  }

  public Smiley getSmiley() {
    return this.smiley;
  }

  public TimerDisplay getTimer() {
    return this.timer;
  }
}
