import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.BorderFactory;

public class NewRecordDialog extends JDialog implements ActionListener, WindowListener {
  private static final long serialVersionUID = -7317311608209462993L;

  private Minesweeper main;

  private JTextField name;

  public NewRecordDialog(Minesweeper main) {
    super(main, "", true);
    this.main = main;
    this.name = new JTextField("Anonymous");
    JPanel panel = new JPanel();
    add(panel);
    panel.setLayout(new GridBagLayout());
    panel.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
    GridBagConstraints c =
        new GridBagConstraints(
            1,
            3,
            1,
            1,
            0.0,
            1.0,
            GridBagConstraints.CENTER,
            GridBagConstraints.NONE,
            new Insets(15, 15, 15, 15),
            0,
            0);
    c.gridx = 0;
    c.gridy = 0;
    panel.add(
        new JLabel(
            "<html><center>You have the fastest time<br>for "
                + this.getLevel()
                + " level.<br>Please enter your name.</center></html>"),
        c);
    c.gridy = 1;
    panel.add(this.name, c);
    c.gridy = 2;
    JButton ok = new JButton("OK");
    panel.add(ok, c);
    this.getRootPane().setDefaultButton(ok);
    ok.addActionListener(this);
    pack();
    setResizable(false);
    Rectangle screenSize = getGraphicsConfiguration().getBounds();
    setLocation(
        screenSize.x + screenSize.width / 2 - getSize().width / 2,
        screenSize.y + screenSize.height / 2 - getSize().height / 2);
    setVisible(true);
  }

  public String getLevel() {
    switch (this.main.getStorage().getDifficulty()) {
      case 0:
        return "beginner";
      case 1:
        return "intermediate";
      case 2:
        return "expert";
    }
    return "";
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    Storage data = this.main.getStorage();
    data.setRecord(data.getDifficulty(), this.main.getInfo().getTimer().getTime());
    data.setName(data.getDifficulty(), this.name.getText());
    this.dispose();
  }

  @Override
  public void windowClosing(WindowEvent e) {}

  @Override
  public void windowOpened(WindowEvent e) {}

  @Override
  public void windowClosed(WindowEvent e) {}

  @Override
  public void windowIconified(WindowEvent e) {}

  @Override
  public void windowDeiconified(WindowEvent e) {}

  @Override
  public void windowActivated(WindowEvent e) {}

  @Override
  public void windowDeactivated(WindowEvent e) {}
}
