import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import javax.swing.*;

public class Resource {
  private BufferedImage digit;
  private BufferedImage smiley;
  private BufferedImage tile;

  private final String RES_TILE = "410.png";
  private final String RES_DIGIT = "420.png";
  private final String RES_SMILEY = "430.png";

  private BufferedImage loadImage(String filename) {
    BufferedImage image;
    try {
      image = ImageIO.read(getClass().getResourceAsStream(filename));
    } catch (Exception e) {
      JOptionPane.showMessageDialog(null, "Error: Image Loading Failed.");
      image = null;
    }
    return image;
  }

  public Resource() {
    this.digit = this.loadImage(this.RES_DIGIT);
    this.smiley = this.loadImage(this.RES_SMILEY);
    this.tile = this.loadImage(this.RES_TILE);
  }

  public BufferedImage getDigit() {
    return this.digit;
  }

  public BufferedImage getSmiley() {
    return this.smiley;
  }

  public BufferedImage getTile() {
    return this.tile;
  }
}
