import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import javax.swing.*;

public class Smiley extends JLabel implements MouseListener {
  private static final long serialVersionUID = -1028805830774712972L;

  private Board board;
  private BufferedImage image;

  private final int SIZE = 24;

  public Smiley(Board board) {
    super("", JLabel.CENTER);
    this.board = board;
    this.image = this.board.getMain().getImage().getSmiley();
    this.setSmileyIcon("smile");
    addMouseListener(this);
    setVerticalAlignment(JLabel.CENTER);
    setHorizontalAlignment(JLabel.CENTER);
    setPreferredSize(new Dimension(this.SIZE, this.SIZE));
  }

  public int topMargin(String state) {
    String[] states = {"smile down", "boss", "death", "oops", "smile"};
    for (int i = 0; i < states.length; i += 1) {
      if (states[i].equals(state)) {
        return i;
      }
    }
    return 3;
  }

  public void setSmileyIcon(String state) {
    setIcon(
        new ImageIcon(
            this.image.getSubimage(0, this.SIZE * this.topMargin(state), this.SIZE, this.SIZE)));
  }

  @Override
  public void mousePressed(MouseEvent e) {
    if (SwingUtilities.isLeftMouseButton(e)) {
      this.setSmileyIcon("smile down");
    }
  }

  @Override
  public void mouseReleased(MouseEvent e) {
    if (SwingUtilities.isLeftMouseButton(e)) {
      this.setSmileyIcon("smile");
      this.board.getMain().newGame();
    }
  }

  @Override
  public void mouseExited(MouseEvent e) {}

  @Override
  public void mouseEntered(MouseEvent e) {}

  @Override
  public void mouseClicked(MouseEvent e) {}
}
